AdminCaja/Areas/Admin/Models/Services/ServiceContentListViewModel.cs
using Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace AdminCaja.Areas.Admin.Models.Services
{
    public class ServiceContentListViewModel
    {
        [Key]
        public int Id { get; set; }

        [Display(Name = "Title", ResourceType = typeof(L))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(L))]
        public string Title { get; set; }

    }
}

AdminCaja/Areas/Admin/Models/Services/ServiceContentViewModel.cs
using Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace AdminCaja.Areas.Admin.Models.Services
{
    public class ServiceContentViewModel
    {
        [Key]
        public int Id { get; set; }

        [Display(Name ="Title", ResourceType =typeof(L))]
        [Required(ErrorMessageResourceName ="Required", ErrorMessageResourceType =typeof(L))]
        public string Title { get; set; }
        [AllowHtml]
        public string Body { get; set; }
        public string Language { get; set; }
        public int ServiceId { get; set; }
        public string ServiceTitle { get; set; }
    }
}

AdminCaja/Areas/Admin/Models/Services/ServiceListViewModel.cs
using Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace AdminCaja.Areas.Admin.Models.Services
{
    public class ServiceListViewModel
    {
        [Key]
        public int Id { get; set; }

        [Display(Name = "Title", ResourceType = typeof(L))]
        [Required]
        [MaxLength(25)]
        public string Title { get; set; }

    }
}

AdminCaja/Areas/Admin/Models/Services/ServiceViewModel.cs
using AdminCaja.Models;
using Resources;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace AdminCaja.Areas.Admin.Models.Services
{
    public class ServiceViewModel
    {
        [Key]
        public int Id { get; set; }
        [Display(Name ="CardTitle", ResourceType =typeof(L))]
        [Required(ErrorMessageResourceName ="Required", ErrorMessageResourceType =typeof(L))]
        [MaxLength(25)]
        public string Title { get; set; }

        [Display(Name ="Description", ResourceType =typeof(L))]
        public string Description { get; set; }

        [Display(Name= "HoverText", ResourceType =typeof(L))]
        public string HoverText { get; set; }
        public virtual Collection<Procedure> Procedures { get; set; }
        public virtual Collection<ServiceContent> Contents { get; set; }

    }
}

AdminCaja/Areas/Admin/Controllers/ServicesController.cs
using AdminCaja.Areas.Admin.Models;
using AdminCaja.Areas.Admin.Models.Services;
using AdminCaja.Controllers;
using AdminCaja.Helpers;
using AdminCaja.Models;
using AutoMapper;
using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace AdminCaja.Areas.Admin.Controllers
{
    public class ServicesController : BaseController
    {
        private ApplicationDbContext _context;
        private IMapper _mapper;

        public ServicesController(ApplicationDbContext context, IMapper mapper)
        {
            _context = context;
            _mapper = mapper;
        }

 #region Services
        // GET: Admin/Services
        public async Task<ActionResult> Index(int itemsPerPage = 10, int Page = 1)
        {
            PaggedData<ServiceListViewModel> result = new PaggedData<ServiceListViewModel>();

            result.Items = await _context.Services.CountAsync();
            result.ItemsPerPage = itemsPerPage;
            result.CurrentPage = Page;

            var services = await _context.Services
                .OrderBy(x => x.Id)
                .Skip(result.ItemsPerPage * (result.CurrentPage - 1))
                .Take(result.ItemsPerPage)
                .ToListAsync();

            result.Data = _mapper.Map<List<Service>, List<ServiceListViewModel>>(services);

            return View(result);
        }

        public ActionResult NewService()
        {
            var vm = new ServiceViewModel();
            return View("FormService", vm);
        }

        public async Task<ActionResult> EditService(int Id)
        {
            var service = await _context.Services.Include(x => x.Contents).FirstOrDefaultAsync(x => x.Id == Id);
            return View("FormService", _mapper.Map<ServiceViewModel>(service));
        }

        [HttpPost]
        public async Task<ActionResult> SaveService(ServiceViewModel model)
        {
            if (ModelState.IsValid)
            {
                var savedService = await _context.Services
                    .Include(x => x.Contents)
                    .FirstOrDefaultAsync(x => x.Id == model.Id);

                if(savedService == null)
                {
                    savedService = _mapper.Map<Service>(model);
                    _context.Services.Add(savedService);
                }
                else
                {
                    _mapper.Map(model, savedService);
                }

                await _context.SaveChangesAsync();

                model = _mapper.Map<ServiceViewModel>(savedService);
            }

            return View("FormService", model);
        }

        public async Task<ActionResult> DeleteService(int Id)
        {
            var service = await _context.Services
                        .FirstOrDefaultAsync(x => x.Id == Id);

            var vm = _mapper.Map<ServiceListViewModel>(service);
            return PartialView(vm);
        }

        [HttpPost]
        public async Task<ActionResult> ConfirmDeleteService(int Id)
        {
            var service = await _context.Services
            .FirstOrDefaultAsync(x => x.Id == Id);

            if(service != null)
            {
                _context.Services.Remove(service);
                await _context.SaveChangesAsync();
            }

            return Json(new ResultModelModalResult { execute = true});
        }
        #endregion
        
        #region ServiceContent
        public async Task<ActionResult> EditServiceContent(int Id = -1, string lang = "es", int ServiceId = -1)
        {
            ServiceContentViewModel vm;
            var serviceContent = await _context.ServiceContents
                .Include(x => x.Service)
                .FirstOrDefaultAsync(x => x.Id == Id);

            if(serviceContent == null)
            {
                var service = await _context.Services.FirstOrDefaultAsync(x => x.Id == ServiceId);

                if (service == null)
                    return BadRequest();

                vm = new ServiceContentViewModel() {Language = lang };
                vm.ServiceTitle = service.Title;
                vm.ServiceId = service.Id;
                vm.Language = lang;
            }
            else
            {
                vm = _mapper.Map<ServiceContentViewModel>(serviceContent);
                vm.ServiceTitle = serviceContent.Service?.Title;
            }
            
            return View("FormServiceContent", vm);
        }

        public async Task<ActionResult> SaveServiceContent(ServiceContentViewModel model)
        {
            if (ModelState.IsValid)
            {
                var savedServiceContent = await _context.ServiceContents
                    .Include(x => x.Service)
                    .FirstOrDefaultAsync(x => x.Id == model.Id);

                if (savedServiceContent == null)
                {
                    var service = await _context.Services.FirstOrDefaultAsync(x => x.Id == model.ServiceId);

                    if (service == null)
                        return BadRequest();

                    savedServiceContent = _mapper.Map<ServiceContent>(model);
                    savedServiceContent.Service = service;
                    _context.ServiceContents.Add(savedServiceContent);
                }
                else
                {
                    _mapper.Map(model, savedServiceContent);
                }

                await _context.SaveChangesAsync();

                model = _mapper.Map<ServiceContentViewModel>(savedServiceContent);

                return RedirectToAction("EditService", new { Id = model.ServiceId });
            }

            return View("FormServiceContent", model);
        }

        public async Task<ActionResult> DeleteServiceContent(int Id)
        {
            var service = await _context.ServiceContents
                        .FirstOrDefaultAsync(x => x.Id == Id);

            var vm = _mapper.Map<ServiceContentListViewModel>(service);
            return PartialView(vm);
        }

        [HttpPost]
        public async Task<ActionResult> ConfirmDeleteServiceContent(int Id)
        {
            int ServiceId = 0;
            var serviceContent = await _context.ServiceContents
            .FirstOrDefaultAsync(x => x.Id == Id);

            if (serviceContent != null)
            {
                ServiceId = serviceContent.ServiceId;
                _context.ServiceContents.Remove(serviceContent);
                await _context.SaveChangesAsync();
            }

            return Json(new ResultModelModalResult { url = $"/Admin/Services/GetContentList/{ServiceId}" });
        }

        public async Task<ActionResult> GetContentList(int Id)
        {
            var service = await _context.Services.Include(x => x.Contents).FirstOrDefaultAsync(x => x.Id == Id);
            return PartialView("FormServiceListContent", _mapper.Map<ServiceViewModel>(service));
        }

        #endregion

    }
}

AdminCaja/Areas/Admin/Views/Services/DeleteService.cshtml
@using AdminCaja.Areas.Admin.Models.Services
@model ServiceListViewModel

@using (Html.BeginForm("ConfirmDeleteService", "Services", FormMethod.Post, new { @class = "form-horizontal form-material" }))
{
    @Html.HiddenFor(m => m.Id)
    @Html.AntiForgeryToken()

    <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel">Eliminar Servicio</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <p>¿Estás seguro de eliminar el servicio @Model.Title? Se eliminarán sus contenidos completamente del sitio.</p>
    </div>

    <div class="modal-footer">
        <button type="submit" class="btn btn-primary">Eliminar</button>
        <button type="button" data-dismiss="modal" class="btn btn-primary">Cancelar</button>
    </div>
}

AdminCaja/Areas/Admin/Views/Services/DeleteServiceContent.cshtml
@using AdminCaja.Areas.Admin.Models.Services
@model ServiceContentListViewModel

@using (Html.BeginForm("ConfirmDeleteServiceContent", "Services", FormMethod.Post, new { @class = "form-horizontal form-material" }))
{
    @Html.HiddenFor(m => m.Id)
    @Html.AntiForgeryToken()

    <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel">Eliminar Servicio</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <p>¿Estás seguro de eliminar el contenido @Model.Title? Se eliminarán sus contenidos completamente del sitio.</p>
    </div>

    <div class="modal-footer">
        <button type="submit" class="btn btn-primary">Eliminar</button>
        <button type="button" data-dismiss="modal" class="btn btn-primary">Cancelar</button>
    </div>
}

AdminCaja/Areas/Admin/Views/Services/FormService.cshtml
@using AdminCaja.Areas.Admin.Models.Services
@model ServiceViewModel

<div class="row page-titles">
    <div class="col-md-5 col-8 align-self-center">
        <h3 class="text-themecolor m-b-0 m-t-0">Secciones</h3>
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="/Admin">Inicio </a></li>
            <li class="breadcrumb-item"><a href="/Admin/Services">Servicios</a></li>
            <li class="breadcrumb-item active">@Model.Title</li>
        </ol>
    </div>
</div>
<!-- ============================================================== -->
<!-- End Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<!-- ============================================================== -->
<!-- Start Page Content -->
<!-- ============================================================== -->
<div class="row">
    <!-- column -->
    <div class="col-lg-12 help-content">
        <div id="" class="card wow slideInRight" data-wow-delay=".3s" data-wow-offset="300">
            <div class="perfil-head"></div>
            <div class="card-block">
                @using (Html.BeginForm("SaveService", "Services", FormMethod.Post))
                {
                    <input type="hidden" name="Id" id="Id" value="@Model.Id" />
                    @Html.AntiForgeryToken()

                    <div class="form-group">
                        <label for="message-text" class="col-form-label">Título tarjeta</label>
                        @Html.EditorFor(m => m.Title, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(m=> m.Title)
                    </div>
                    <div class="form-group">
                        <label for="" class="col-form-label">Descripción de tarjeta</label>
                        @Html.TextAreaFor(m => m.Description, new { @class = "form-control" })
                        @Html.ValidationMessageFor(m => m.Description)
                    </div>
                    <div class="form-group">
                        <label for="" class="col-form-label">Texto hover</label>
                        @Html.TextAreaFor(m => m.HoverText, new { @class = "form-control" })
                        @Html.ValidationMessageFor(m => m.HoverText)
                    </div>
                    <div class="col-md-12 mt-5">
                        <button type="submit" class="btn btn-primary u-btn-primary transition-3d-hover">Guardar</button>
                    </div>
                }
            </div>

            @if(Model.Id != 0)
            {
                <dir class="row">
                    <div class="col-lg-8"></div>
                    <div class="col-lg-4">
                        <p><a href="/Admin/Services/EditServiceContent/-1?ServiceId=@Model.Id" class="btn btn-success">Agregar sección</a></p>
                    </div>
                </dir>

                <div class="card-block" data-modal-target="popup">
                    @Html.Partial("FormServiceListContent", Model)
                </div>
            }
        </div>
    </div>
</div>

@section scripts{
    <script>

    </script>
    }

AdminCaja/Areas/Admin/Views/Services/FormServiceContent.cshtml
@using AdminCaja.Areas.Admin.Models.Services
@using AdminCaja.Areas.Admin.Models

@model ServiceContentViewModel

@{
    var lenguajes = new List<DefinicionLenguajes> { new DefinicionLenguajes { Name = "Español", lang = "es" }, new DefinicionLenguajes { Name = "Inglés", lang = "en" } };
}

<!-- ============================================================== -->
<!-- Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<div class="row page-titles">
    <div class="col-md-5 col-8 align-self-center">
        <h3 class="text-themecolor m-b-0 m-t-0">Editar Contenidos</h3>
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="/Admin">Inicio </a></li>
            <li class="breadcrumb-item"><a href="/Admin/Services">Servicios</a></li>
            <li class="breadcrumb-item"><a href="/Admin/Services/EditService/@Model.ServiceId">@Model.ServiceTitle</a></li>
            <li class="breadcrumb-item active">Contenido</li>
        </ol>
    </div>
</div>
<!-- ============================================================== -->
<!-- End Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<!-- ============================================================== -->
<!-- Start Page Content -->
<!-- ============================================================== -->
<div class="row">
    <div class="col-12 help-content">
        <ul class="nav nav-tabs wow slideInRight" data-wow-offset="300" id="myTab" role="tablist">
            @foreach (var item in lenguajes)
            {
                if (item.lang == Model.Language)
                {
                    <li class="nav-item">
                        <a class="nav-link active" id="spa-tab" data-toggle="tab" href="#langactivo" role="tab" aria-controls="spa" aria-selected="true">@item.Name</a>
                    </li>

                }
                else
                {
                    <li class="nav-item">
                        <a class="nav-link" id="@item.lang-tab" href="/Admin/Services/EditServiceContent/?ServiceId=@Model.ServiceId&lang=@item.lang" role="tab" aria-controls="eng" aria-selected="false">@item.Name</a>
                    </li>
                }

            }
        </ul>
        <div class="card wow slideInRight" data-wow-offset="300">
            <!-- <div class="card-block bg-info">
                                <h4 class="text-white card-title">Glosario</h4>
                            </div> -->
            <div class="card-block">
                <div class="tab-content" id="myTabContent">
                    <div class="tab-pane show active" id="spa" role="tabpanel" aria-labelledby="spa-tab">
                        @using (Html.BeginForm("SaveServiceContent", "Services", FormMethod.Post, new { @class = "form-horizontal form-material" }))
                        {
                            <input type="hidden" name="Id" value="@Model.Id" />
                            <input type="hidden" name="ServiceId" value="@Model.ServiceId" />
                            <input type="hidden" name="Language" value="@Model.Language" />
                            <div class="form-group">
                                @Html.LabelFor(m => m.Title, new { htmlAttributes = new { @class = "form-control form-control-line" } })
                                @Html.EditorFor(m => m.Title, new { htmlAttributes = new { @class = "form-control form-control-line" } })
                                @Html.ValidationMessageFor(m => m.Title)
                            </div>


                            <div id="target">
                                <div class="form-group">
                                    <label class="h6 small d-block text-uppercase">Cuerpo de publicación</label>
                                    <div class="js-focus-state input-group u-form">
                                        <div class="u-summernote-editor" style="width: 100%">
                                            @Html.TextAreaFor(m => m.Body, new { @class = "js-summernote-editor", data_height = "240" })
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <button type="submit" class="btn btn-primary u-btn-primary transition-3d-hover">Guardar</button>
                            </div>
                        }
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- ============================================================== -->
<!-- End PAge Content -->
<!-- ============================================================== -->
@section  Scripts{

    <script>
        $(document).on('ready', function () {
            // initialization of select picker
            $.HSCore.components.HSSelectPicker.init('.js-select');

            // initialization of text editors
            initSummerNote();
            // initialization of range datepicker
            $.HSCore.components.HSRangeDatepicker.init('.js-range-datepicker');
        });
        function initSummerNote() {
                 $.HSCore.components.HSSummernoteEditor.init('.js-summernote-editor');
        }
    </script>
}

AdminCaja/Areas/Admin/Views/Services/FormServiceListContent.cshtml
@using AdminCaja.Areas.Admin.Models.Services
@model ServiceViewModel

<div class="table-responsive">
    <nav aria-label="Page navigation example">
        <ul class="pagination justify-content-end">
            <li class="page-item res-per-page">Página <strong>1/1</strong></li>
            <li class="page-item res-per-page">Resultados por página</li>
            <li class="page-item ">
                <select name="resurlt" form="">
                    <option value="10">10</option>
                    <option value="20">20</option>
                    <option value="30">30</option>
                    <option value="40">40</option>
                </select>
            </li>
        </ul>
    </nav>
    <br>
    <table>
        <thead>
            <tr>
                <th scope="col">ID</th>
                <th scope="col">Título</th>
                <th scope="col">Acciones</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var item in Model.Contents)
            {
                <tr>
                    <td data-label="ID">@item.Id</td>
                    <td data-label="Título">@item.Title</td>
                    <td class="comandos" data-label="Acciones">
                        <a href="/Admin/Services/EditServiceContent/@item.Id" class="btn btn-export">Editar</a>
                        <a href="/Admin/Services/DeleteServiceContent/@item.Id" class="btn btn-export" data-modal="popup">Eliminar</a>
                    </td>
                </tr>

            }
        </tbody>
    </table>
    <br>
    <div class="resultados">
        <p>Resultados encontrados: <strong>20</strong></p>
    </div>
    <nav aria-label="Page navigation example" class="paginado">
        <ul class="pagination justify-content-end">
            <li class="page-item disabled"> <a class="page-link" href="#" tabindex="-1">Anterior</a> </li>
            <li class="page-item"><a class="page-link" href="#">1</a></li>
            <li class="page-item"><a class="page-link" href="#">2</a></li>
            <li class="page-item"><a class="page-link" href="#">3</a></li>
            <li class="page-item"> <a class="page-link" href="#">Siguiente</a> </li>
        </ul>
    </nav>
</div>

AdminCaja/Areas/Admin/Views/Services/Index.cshtml
@using AdminCaja.Areas.Admin.Models
@using AdminCaja.Areas.Admin.Models.Services

@model PaggedData<ServiceListViewModel>


<!-- ============================================================== -->
<!-- Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<div class="row page-titles">
    <div class="col-md-5 col-8 align-self-center">
        <h3 class="text-themecolor m-b-0 m-t-0">Servicios</h3>
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="/Admin">Inicio </a></li>
            <li class="breadcrumb-item active">Servicios</li>
        </ol>
    </div>
</div>
<!-- ============================================================== -->
<!-- End Bread crumb and right sidebar toggle -->
<!-- ============================================================== -->
<!-- ============================================================== -->
<!-- Start Page Content -->
<!-- ============================================================== -->
<div class="row">
    <!-- column -->
    <div class="col-lg-12 help-content">
        <div id="" class="card wow slideInRight" data-wow-delay=".3s" data-wow-offset="300">
            <div class="perfil-head"></div>
            <dir class="row">
                <div class="col-lg-8"></div>
                <div class="col-lg-4">
                    <p>@Html.ActionLink("Agregar servicio", "NewService", null, new { @class = "btn btn-success" })</p>
                </div>
            </dir>
            <div class="card-block">
                <div class="table-responsive">
                    <nav aria-label="Page navigation example">
                        <ul class="pagination justify-content-end">
                            <li class="page-item res-per-page">Página <strong>1/1</strong></li>
                            <li class="page-item res-per-page">Resultados por página</li>
                            <li class="page-item ">
                                <select name="resurlt" form="">
                                    <option value="10">10</option>
                                    <option value="20">20</option>
                                    <option value="30">30</option>
                                    <option value="40">40</option>
                                </select>
                            </li>
                        </ul>
                    </nav>
                    <br>
                    <table>
                        <thead>
                            <tr>
                                <th scope="col">ID</th>
                                <th scope="col">Título</th>
                                <th scope="col">Acciones</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var item in Model.Data)
                            {
                                <tr>
                                    <td data-label="Título">@item.Id</td>
                                    <td data-label="Título">@item.Title</td>
                                    <td class="comandos" data-label="Acciones">
                                        @Html.ActionLink("Editar", "EditService", new { Id = item.Id }, new { @class = "btn btn-export" })
                                        @Html.ActionLink("Eliminar", "DeleteService", new { Id = item.Id }, new { @class = "btn btn-export", data_modal="popup" })
                                    </td>
                                </tr>

                            }
                        </tbody>
                    </table>
                    @Html.Partial("_paggedBar", Model)
                </div>
            </div>
        </div>
    </div>
</div>
<!-- ============================================================== -->
<!-- End PAge Content -->
<!-- ============================================================== -->
@section scripts{
    <script>
        function modalFormExecute(key, result) {
            window.location.href = "/Admin/Services"
        }
    </script>
    }